(* Given a normalized probability function f[x,y,z] or f[r,theta,phi] Plot the
3 Dimensional probability density distribution 
 by Jason Kodish 
Thirring Institute *)

BeginPackage["probplot`"]                     

ProbabilityPlot::usage="ProbabilityPlot[f[x,y,z],{x,xmin,xmax},{y,ymin,ymax},{
z,zmin,zmax}] gives a plot of the probability density of f."

ProbabilityPlotSpherical::usage="ProbabilityPlot[f[r,theta,phi],{r,rmin,rmax},{theta,
thetamin,thetamax},{phi,phimin,phimax}] gives a plot of the probability density of f
in spherical coordinates."


Begin["Private`"]

 
Change[{r_,phi_,theta_}]:={r*Cos[phi] Sin[theta],r*Sin[phi]*Sin[theta],r*
Cos[theta]};
ProbabilityPlot[f_,xrange_,yrange_,zrange_]:=Block[{length,RNDList,x,y,z,
ProbabilityList,PointList,TruthList,PositionList},ProbabilityList=Flatten[Table[f,xrange,yrange,zrange]]//N;
length=Length[ProbabilityList];RNDList=Table[Random[],{i,1,length}];
TruthList=Thread[RNDList<ProbabilityList];PointList={};PositionList=
Flatten[Table[{xrange[[1]],yrange[[1]],zrange[[1]]},xrange,yrange,zrange],2];
Do[If[TruthList[[i]]==True,PointList=
Join[PointList,{PositionList[[i]]}]],{i,1,length}];Show[Graphics3D[Point/@PointList]]]

ProbabilityPlotSpherical[f_,rrange_,thetarange_,phirange_]:=Block[{length,RNDList,
ProbabilityList,PointList,TruthList,PositionList},ProbabilityList=Flatten[Table[f,rrange,
thetarange,phirange]]//N;
length=Length[ProbabilityList];RNDList=Table[Random[],{i,1,length}];
TruthList=Thread[RNDList<ProbabilityList];PointList={};PositionList=
Flatten[Table[{rrange[[1]],phirange[[1]],thetarange[[1]]},rrange,thetarange,phirange],2];
Do[If[TruthList[[i]]==True,PointList=
Join[PointList,{PositionList[[i]]}]],{i,1,length}];Show[Graphics3D[Point/@
Map[Change,PointList,1]]]]

End[]
EndPackage[]













